theory TailRec imports S TailRec_nat
begin

consts
  s2 :: " (a list \<times> a) \<Rightarrow> a "

recdef s2 "measure(\<lambda>(x, y). length x)"
  "s2 (x, y) = (if (x = Nil) then y else (s2 (tl x, p y (hd x))))"

lemma s2_Nil: " s2 (Nil, y) = y " by simp
lemma s2_Cons: " s2 (x#xs, y) = s2 (xs, p y x) " by simp

theorem TailRec: "s x = s2 (x, z)"
proof (rule abs_eq)
  fix u show "s u = (if u = [] then z else p (hd u) (s (tl u)))" by (rule Ax_s)
 next
  fix x show "p z x = x" by (rule LeftOne)
 next
  fix e u show "s2 (u, e) = (if u = [] then e else s2 (tl u, p e (hd u)))" by (rule s2.simps) 
 next
  fix x show "p x z = x" by (rule RightOne)
 next
  fix a b c show "p a (p b c) = p (p a b) c" by (rule Assoc)
qed

end
